# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CostManagement::Mgmt::V2018_05_31
  module Models
    #
    # A report config resource.
    #
    class ReportConfig < Resource

      include MsRestAzure

      # @return [ReportConfigSchedule] Has schedule information for the report
      # config.
      attr_accessor :schedule

      # @return [FormatType] The format of the report being delivered. Possible
      # values include: 'Csv'
      attr_accessor :format

      # @return [ReportConfigDeliveryInfo] Has delivery information for the
      # report config.
      attr_accessor :delivery_info

      # @return [ReportConfigDefinition] Has definition for the report config.
      attr_accessor :definition


      #
      # Mapper for ReportConfig class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ReportConfig',
          type: {
            name: 'Composite',
            class_name: 'ReportConfig',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              schedule: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.schedule',
                type: {
                  name: 'Composite',
                  class_name: 'ReportConfigSchedule'
                }
              },
              format: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.format',
                type: {
                  name: 'String'
                }
              },
              delivery_info: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.deliveryInfo',
                type: {
                  name: 'Composite',
                  class_name: 'ReportConfigDeliveryInfo'
                }
              },
              definition: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.definition',
                default_value: {},
                type: {
                  name: 'Composite',
                  class_name: 'ReportConfigDefinition'
                }
              }
            }
          }
        }
      end
    end
  end
end
