# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CostManagement::Mgmt::V2019_01_01
  module Models
    #
    # The destination information for the delivery of the export. To allow
    # access to a storage account, you must register the account's subscription
    # with the Microsoft.CostManagementExports resource provider. This is
    # required once per subscription. When creating an export in the Azure
    # portal, it is done automatically. However, API users need to register the
    # subscription. For more information see
    # https://docs.microsoft.com/en-us/azure/azure-resource-manager/resource-manager-supported-services
    # .
    #
    class ExportDeliveryDestination

      include MsRestAzure

      # @return [String] The resource id of the storage account where exports
      # will be delivered.
      attr_accessor :resource_id

      # @return [String] The name of the container where exports will be
      # uploaded.
      attr_accessor :container

      # @return [String] The name of the directory where exports will be
      # uploaded.
      attr_accessor :root_folder_path


      #
      # Mapper for ExportDeliveryDestination class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ExportDeliveryDestination',
          type: {
            name: 'Composite',
            class_name: 'ExportDeliveryDestination',
            model_properties: {
              resource_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'resourceId',
                type: {
                  name: 'String'
                }
              },
              container: {
                client_side_validation: true,
                required: true,
                serialized_name: 'container',
                type: {
                  name: 'String'
                }
              },
              root_folder_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'rootFolderPath',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
