# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CostManagement::Mgmt::V2019_01_01
  module Models
    #
    # The definition of data present in the query.
    #
    class QueryDataset

      include MsRestAzure

      # @return [GranularityType] The granularity of rows in the query.
      # Possible values include: 'Daily', 'Hourly'
      attr_accessor :granularity

      # @return [QueryDatasetConfiguration] Has configuration information for
      # the data in the export. The configuration will be ignored if
      # aggregation and grouping are provided.
      attr_accessor :configuration

      # @return [Hash{String => QueryAggregation}] Dictionary of aggregation
      # expression to use in the query. The key of each item in the dictionary
      # is the alias for the aggregated column. Query can have up to 2
      # aggregation clauses.
      attr_accessor :aggregation

      # @return [Array<QueryGrouping>] Array of group by expression to use in
      # the query. Query can have up to 2 group by clauses.
      attr_accessor :grouping

      # @return [Array<QuerySortingConfiguration>] Array of sorting by columns
      # in query.
      attr_accessor :sorting

      # @return [QueryFilter] Has filter expression to use in the query.
      attr_accessor :filter


      #
      # Mapper for QueryDataset class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'QueryDataset',
          type: {
            name: 'Composite',
            class_name: 'QueryDataset',
            model_properties: {
              granularity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'granularity',
                type: {
                  name: 'String'
                }
              },
              configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'configuration',
                type: {
                  name: 'Composite',
                  class_name: 'QueryDatasetConfiguration'
                }
              },
              aggregation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'aggregation',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'QueryAggregationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'QueryAggregation'
                      }
                  }
                }
              },
              grouping: {
                client_side_validation: true,
                required: false,
                serialized_name: 'grouping',
                constraints: {
                  MaxItems: 2
                },
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'QueryGroupingElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'QueryGrouping'
                      }
                  }
                }
              },
              sorting: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sorting',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'QuerySortingConfigurationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'QuerySortingConfiguration'
                      }
                  }
                }
              },
              filter: {
                client_side_validation: true,
                required: false,
                serialized_name: 'filter',
                type: {
                  name: 'Composite',
                  class_name: 'QueryFilter'
                }
              }
            }
          }
        }
      end
    end
  end
end
