# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CostManagement::Mgmt::V2019_03_01_preview
  module Models
    #
    # The Connector model definition
    #
    class ConnectorDefinition

      include MsRestAzure

      # @return [String] Connector kind (eg aws)
      attr_accessor :kind

      # @return [String] Connector id
      attr_accessor :id

      # @return [String] Connector name
      attr_accessor :name

      # @return [String] Connector type
      attr_accessor :type

      # @return [String] Connector DisplayName
      attr_accessor :display_name

      # @return [String] Connector providerBillingAccountId, determined from
      # credentials (eg AWS Consolidated account number)
      attr_accessor :provider_billing_account_id

      # @return [String] The display name of the providerBillingAccountId as
      # defined on the external provider
      attr_accessor :provider_billing_account_display_name

      # @return [String] Credentials authentication key (eg AWS ARN)
      attr_accessor :credentials_key

      # @return [String] Credentials secret (eg AWS ExternalId)
      attr_accessor :credentials_secret

      # @return [String] Identifying source report. (For AWS this is a CUR
      # report name, defined with Daily and with Resources)
      attr_accessor :report_id

      # @return [DateTime] Connector definition creation datetime
      attr_accessor :created_on

      # @return [DateTime] Connector last modified datetime
      attr_accessor :modified_on

      # @return [ConnectorStatus] Connector status. Possible values include:
      # 'active', 'error', 'expired', 'warning'
      attr_accessor :status

      # @return [String] Associated ExternalBillingAccountId
      attr_accessor :external_billing_account_id

      # @return [String] Default ManagementGroupId
      attr_accessor :default_management_group_id

      # @return [String] Billing SubscriptionId
      attr_accessor :subscription_id

      # @return [ConnectorBillingModel] Connector billing model. Possible
      # values include: 'trial', 'autoUpgrade', 'premium', 'expired'
      attr_accessor :billing_model

      # @return [Integer] Number of days remaining of trial
      attr_accessor :days_trial_remaining

      # @return [ConnectorCollectionInfo] Collection information
      attr_accessor :collection_info


      #
      # Mapper for ConnectorDefinition class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ConnectorDefinition',
          type: {
            name: 'Composite',
            class_name: 'ConnectorDefinition',
            model_properties: {
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              provider_billing_account_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.providerBillingAccountId',
                type: {
                  name: 'String'
                }
              },
              provider_billing_account_display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.providerBillingAccountDisplayName',
                type: {
                  name: 'String'
                }
              },
              credentials_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.credentialsKey',
                type: {
                  name: 'String'
                }
              },
              credentials_secret: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.credentialsSecret',
                type: {
                  name: 'String'
                }
              },
              report_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.reportId',
                type: {
                  name: 'String'
                }
              },
              created_on: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.createdOn',
                type: {
                  name: 'DateTime'
                }
              },
              modified_on: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.modifiedOn',
                type: {
                  name: 'DateTime'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.status',
                type: {
                  name: 'String'
                }
              },
              external_billing_account_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.externalBillingAccountId',
                type: {
                  name: 'String'
                }
              },
              default_management_group_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.defaultManagementGroupId',
                type: {
                  name: 'String'
                }
              },
              subscription_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.subscriptionId',
                type: {
                  name: 'String'
                }
              },
              billing_model: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.billingModel',
                type: {
                  name: 'String'
                }
              },
              days_trial_remaining: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.daysTrialRemaining',
                type: {
                  name: 'Number'
                }
              },
              collection_info: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.collectionInfo',
                type: {
                  name: 'Composite',
                  class_name: 'ConnectorCollectionInfo'
                }
              }
            }
          }
        }
      end
    end
  end
end
