# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CostManagement::Mgmt::V2019_03_01_preview
  module Models
    #
    # The definition of a report config.
    #
    class ReportConfigDefinition

      include MsRestAzure

      # @return [String] The type of the report. Usage represents actual usage,
      # forecast represents forecasted data and UsageAndForecast represents
      # both usage and forecasted data. Actual usage and forecasted data can be
      # differentiated based on dates. Default value: 'Usage' .
      attr_accessor :type

      # @return [TimeframeType] The time frame for pulling data for the report.
      # If custom, then a specific time period must be provided. Possible
      # values include: 'WeekToDate', 'MonthToDate', 'YearToDate', 'Custom'
      attr_accessor :timeframe

      # @return [ReportConfigTimePeriod] Has time period for pulling data for
      # the report.
      attr_accessor :time_period

      # @return [ReportConfigDataset] Has definition for data in this report
      # config.
      attr_accessor :dataset


      #
      # Mapper for ReportConfigDefinition class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ReportConfigDefinition',
          type: {
            name: 'Composite',
            class_name: 'ReportConfigDefinition',
            model_properties: {
              type: {
                client_side_validation: true,
                required: true,
                is_constant: true,
                serialized_name: 'type',
                default_value: 'Usage',
                type: {
                  name: 'String'
                }
              },
              timeframe: {
                client_side_validation: true,
                required: true,
                serialized_name: 'timeframe',
                type: {
                  name: 'String'
                }
              },
              time_period: {
                client_side_validation: true,
                required: false,
                serialized_name: 'timePeriod',
                type: {
                  name: 'Composite',
                  class_name: 'ReportConfigTimePeriod'
                }
              },
              dataset: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dataset',
                type: {
                  name: 'Composite',
                  class_name: 'ReportConfigDataset'
                }
              }
            }
          }
        }
      end
    end
  end
end
